/**
 * License Agreement.
 *
 * Ajax4jsf 1.1 - Natural Ajax for Java Server Faces (JSF)
 *
 * Copyright (C) 2007 Exadel, Inc.
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Lesser General Public
 * License version 2.1 as published by the Free Software Foundation.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public
 * License along with this library; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA 02110-1301  USA
 */

package org.richfaces.renderkit.html;


// 
// Imports
//
import java.util.Iterator;
import java.util.Collection;
import java.io.IOException;
import javax.faces.component.UIComponent;
import javax.faces.context.FacesContext;
import javax.faces.context.ResponseWriter;
import org.ajax4jsf.framework.renderer.ComponentsVariableResolver;
import org.ajax4jsf.framework.renderer.ComponentVariables;
//
//
//


import org.richfaces.renderkit.html.PanelBarItemRendererBase;



/**
 * Renderer for component class org.richfaces.renderkit.html.PanelBarItemRenderer
 */
public class PanelBarItemRenderer extends PanelBarItemRendererBase {

	public PanelBarItemRenderer () {
		super();
	}

	// 
	// Declarations
	//
	// 
	// 
	//


	private String convertToString(Object obj ) {
		return ( obj == null ? "" : obj.toString() );
	}
	private String convertToString(boolean b ) {
		return String.valueOf(b);
	}
	private String convertToString(int b ) {
		return b!=Integer.MIN_VALUE?String.valueOf(b):"";
	}
	private String convertToString(long b ) {
		return b!=Long.MIN_VALUE?String.valueOf(b):"";
	}
	
	/**
	 * Get base component class, targetted for this renderer. Used for check arguments in decode/encode.
	 * @return
	 */
	protected Class getComponentClass() {
		return org.richfaces.component.UIPanelBarItem.class;
	}

	
	public void doEncodeBegin(ResponseWriter writer, FacesContext context, UIComponent component ) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeBegin(writer, context, (org.richfaces.component.UIPanelBarItem)component, variables );
	}		

	public void doEncodeBegin(ResponseWriter writer, FacesContext context, org.richfaces.component.UIPanelBarItem component, ComponentVariables variables ) throws IOException {
	    java.lang.String clientId = component.getClientId(context);
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "class", "dr-pnlbar rich-panelbar dr-pnlbar-ext " + convertToString(component.getPanel().getAttributes().get("styleClass")) );
						getUtils().writeAttribute(writer, "id", clientId );
						getUtils().writeAttribute(writer, "style", component.getPanel().getAttributes().get("style") );
			
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "class", "dr-pnlbar-h rich-panelbar-header " + convertToString(component.getPanel().getAttributes().get("headerClass")) + " " + convertToString(component.getAttributes().get("headerClass")) );
						getUtils().writeAttribute(writer, "style", convertToString(component.getPanel().getAttributes().get("headerStyle")) + ";" + convertToString(component.getAttributes().get("headerStyle")) );
			
writer.writeText(convertToString(component.getAttributes().get("label")),null);

writer.endElement("div");
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "class", "dr-pnlbar-h-act rich-panelbar-header-act " + convertToString(component.getPanel().getAttributes().get("headerClass")) + " " + convertToString(component.getAttributes().get("headerClass")) + " " + convertToString(component.getPanel().getAttributes().get("headerClassActive")) + " " + convertToString(component.getAttributes().get("headerClassActive")) );
						getUtils().writeAttribute(writer, "style", convertToString(component.getPanel().getAttributes().get("headerStyle")) + ";" + convertToString(component.getAttributes().get("headerStyle")) + ";" + convertToString(component.getPanel().getAttributes().get("headerStyleActive")) + ";" + convertToString(component.getAttributes().get("headerStyleActive")) + ";display: none;" );
			
writer.writeText(convertToString(component.getAttributes().get("label")),null);

writer.endElement("div");
writer.startElement("div", component);
			getUtils().writeAttribute(writer, "style", "display: none; width: 100%;" );
			
writer.startElement("table", component);
			getUtils().writeAttribute(writer, "cellpadding", "0" );
						getUtils().writeAttribute(writer, "style", "height: 100%;" );
						getUtils().writeAttribute(writer, "width", "100%" );
			
writer.startElement("tbody", component);

writer.startElement("tr", component);

writer.startElement("td", component);
			getUtils().writeAttribute(writer, "class", "dr-pnlbar-c rich-panelbar-content " + convertToString(component.getPanel().getAttributes().get("contentClass")) + " " + convertToString(component.getAttributes().get("contentClass")) );
						getUtils().writeAttribute(writer, "style", convertToString(component.getPanel().getAttributes().get("contentStyle")) + ";" + convertToString(component.getAttributes().get("contentStyle")) );
			

	}		
	
    public void doEncodeChildren(ResponseWriter writer, FacesContext context, UIComponent component) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeChildren(writer, context, (org.richfaces.component.UIPanelBarItem)component, variables );
	}		

    public void doEncodeChildren(ResponseWriter writer, FacesContext context, org.richfaces.component.UIPanelBarItem component, ComponentVariables variables) throws IOException {
	    
renderChildren(context, component);


	}		

	/* (non-Javadoc)
	 * @see javax.faces.render.Renderer#getRendersChildren()
	 */
	public boolean getRendersChildren() {
		return true;
	}

	public void doEncodeEnd(ResponseWriter writer, FacesContext context, org.richfaces.component.UIPanelBarItem component, ComponentVariables variables) throws IOException {
	  
writer.endElement("td");
writer.endElement("tr");
writer.endElement("tbody");
writer.endElement("table");
writer.endElement("div");
writer.endElement("div");

	}		
	
	public void doEncodeEnd(ResponseWriter writer, FacesContext context, UIComponent component) throws IOException {
		ComponentVariables variables = ComponentsVariableResolver.getVariables(this, component);
		doEncodeEnd(writer, context, (org.richfaces.component.UIPanelBarItem)component, variables );

		ComponentsVariableResolver.removeVariables(this, component);
	}		
	

}
